## EDU.oswego.cs.dl.util.concurrent
Class ObservableSync

    java.lang.Object
      EDU.oswego.cs.dl.util.concurrent.ObservableSync

All Implemented Interfaces:
  Sync

    public class ObservableSync

extends java.lang.Object
implements Sync

The ObservableSync class performs no synchronization itself, but invokes event-style messages to other observer objects upon invocation of Sync methods. These observers typically perform monitoring, logging, or other bookkeeping operations surrounding the object being managed by this Sync object.

Because ObservableSync does not itself perform any synchronization control, the attempt operation always succeeds. This class is typically used (via LayeredSync) as a wrapper around those that do perform synchronization control.

This class is based around a standard Observer design pattern. It is not hard to convert this to instead use a Listener design (as seen in AWT and JavaBeans), by defining associated EventObjects and forwarding them.

[ Introduction to this package. ]

See Also:
  `LayeredSync`

Nested Class Summary
`static interface` `ObservableSync.SyncObserver` Interface for objects that observe ObservableSyncs.

Field Summary
`protected java.lang.Object` `arg_`
`protected CopyOnWriteArraySet` `observers_`

Fields inherited from interface EDU.oswego.cs.dl.util.concurrent.Sync
`ONE_CENTURY, ONE_DAY, ONE_HOUR, ONE_MINUTE, ONE_SECOND, ONE_WEEK, ONE_YEAR`

Constructor Summary
`ObservableSync(java.lang.Object notificationArgument)` Create an ObservableSync that uses the supplied argument for all notifications.

Method Summary
`void` `acquire()` Wait (possibly forever) until successful passage.
`void` `attach(ObservableSync.SyncObserver obs)` Add obs to the set of observers
`boolean` `attempt(long msecs)` Wait at most msecs to pass; report whether passed.
`void` `detach(ObservableSync.SyncObserver obs)` Remove obs from the set of observers.
`java.lang.Object` `getNotificationArgument()` Return the argument used for notifications
`java.util.Iterator` `observers()` Return an iterator that can be used to traverse through current set of observers
`void` `release()` Potentially enable others to pass.
`java.lang.Object` `setNotificationArgument(java.lang.Object notificationArg)` Set the argument used for notifications.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### observers_

    protected final CopyOnWriteArraySet observers_

### arg_

    protected java.lang.Object arg_

Constructor Detail

### ObservableSync

    public ObservableSync(java.lang.Object notificationArgument)

  Create an ObservableSync that uses the supplied argument for all notifications. The argument is typically an object that is being managed by this Sync object.

Method Detail

### getNotificationArgument

    public java.lang.Object getNotificationArgument()

  Return the argument used for notifications

### setNotificationArgument

    public java.lang.Object setNotificationArgument(java.lang.Object notificationArg)

  Set the argument used for notifications.

  Returns:
    the previous value of this argument

### acquire

    public void acquire()

  Description copied from interface: `Sync`
  Wait (possibly forever) until successful passage. Fail only upon interuption. Interruptions always result in `clean' failures. On failure, you can be sure that it has not been acquired, and that no corresponding release should be performed. Conversely, a normal return guarantees that the acquire was successful.

  Specified by:
    `acquire` in interface `Sync`

### attempt

    public boolean attempt(long msecs)

  Description copied from interface: `Sync`
  Wait at most msecs to pass; report whether passed.

  The method has best-effort semantics: The msecs bound cannot be guaranteed to be a precise upper bound on wait time in Java. Implementations generally can only attempt to return as soon as possible after the specified bound. Also, timers in Java do not stop during garbage collection, so timeouts can occur just because a GC intervened. So, msecs arguments should be used in a coarse-grained manner. Further, implementations cannot always guarantee that this method will return at all without blocking indefinitely when used in unintended ways. For example, deadlocks may be encountered when called in an unintended context.

  Specified by:
    `attempt` in interface `Sync`
  Parameters:
    `msecs` - the number of milleseconds to wait. An argument less than or equal to zero means not to wait at all. However, this may still require access to a synchronization lock, which can impose unbounded delay if there is a lot of contention among threads.
  Returns:
    true if acquired

### release

    public void release()

  Description copied from interface: `Sync`
  Potentially enable others to pass.

  Because release does not raise exceptions, it can be used in `finally' clauses without requiring extra embedded try/catch blocks. But keep in mind that as with any java method, implementations may still throw unchecked exceptions such as Error or NullPointerException when faced with uncontinuable errors. However, these should normally only be caught by higher-level error handlers.

  Specified by:
    `release` in interface `Sync`

### attach

    public void attach(ObservableSync.SyncObserver obs)

  Add obs to the set of observers

### detach

    public void detach(ObservableSync.SyncObserver obs)

  Remove obs from the set of observers. No effect if not in set

### observers

    public java.util.Iterator observers()

  Return an iterator that can be used to traverse through current set of observers